#!/usr/bin/perl -w

# DrawPKL v1.0.2 - Liest Daten fr eine Produktionskennlinie ein und zeichnet sie
# Copyright (C) 2001, 2002 Dirk Swiniartzki (pamela@planet-dirk.de)
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License version 2
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#    General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#    -----------------------------------------------------------
#    Dieses Programm ist freie Software. Sie knnen es unter
#    den Bedingungen der GNU General Public License Version 2,
#    wie von der Free Software Foundation herausgegeben, weitergeben
#    und/oder modifizieren.
#
#    Die Verffentlichung dieses Programms erfolgt in der
#    Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE JEDE
#    GEWHRLEISTUNG - sogar ohne die implizite Gewhrleistung
#    der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN ZWECK.
#    Details finden Sie in der GNU General Public License.
#
#    Sie sollten eine Kopie der GNU General Public License zusammen
#    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
#    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
#    MA 02139, USA.
#    ----------------------------------------------------------------

use strict;
use GD;             # GD-Modul, zu installieren
use File::Basename; # Standardmodul

my @files;    # Liste der Dateien
my @config;   # Konfigurationsdaten
my $a;        # temporre Variable

# ---------- init ----------
# initialisiert das Programm
# Parameter : -
# Rckgabewerte : @config

sub init {

   my @config;   # Nimmt die Konfigurationsdaten auf
#   my ($a, $b);  # temporre Variablen
   my @files;    # Liste der zu bearbeitenden Dateien

   # momentan wird die Konfig mit festen Werten gefllt
   @config=(1024, 768, 100, 100, 100, 100, 3, 3, 1, $ARGV[0]);
   # Konfig : Breite, Hhe, Rand links, rechts, oben, unten, Schriftgre (1-5), Linienbreite1, Linienbreite2, Verzeichnis

   # Jetzt die Dateiliste aufbauen
#   @files=glob("$config[1]pkl_*.csv");

   return(@config);
}

# ---------- drawpkl ----------
# liest die Daten fr die PKL ein und zeichnet sie
# Parameter : @config, Dateiname
# Rckgabewerte :

sub drawpkl {

   my ($breite, $hoehe, $randl, $randr, $rando, $randu, $schrift, $linie1, $linie2, $dir, $datei)=@_;
   my ($a, $b, $c, $d);    # temporre Variablen
   my $bild;               # Handle fr das Bild
   my ($bimin, $lmax, $arbeitssys); # nimmt einige Kennwerte fr die PKL auf
   my %color;             # Handles fr die Farben
   my @xwert;              # Die x-Koordinaten der Kurvenpunkte
   my @ywert1;             # Die y-Koordinaten der Kurvenpunkte - Leistung
   my @ywert2;             # Die y-Koordinaten der Kurvenpunkte - Reichweite
   my ($nullx, $nully);    # x- und y-Wert des Ursprungs des Koordinatensystems - nur eine Erleichterung
   my $xscale;             # Proportionalittsfaktor fr x-Achse
   my ($yscale1, $yscale2);# Proportionalittsfaktor fr y-Achsen : Leistung/Reichweite
   my @data;               # nimmt zu verarbeitenden Datensatz auf
   my ($tiefe, $weite);    # Hhe und Breite der Diagrammflche
   my ($altx, $alty1, $alty2); # Nimmt die voherigen x- und y-Werte auf
   my $error;              # Indikator fr den Fall, da Lmax=0

   # Kennwerte einlesen
   print "Beginne mit Einlesen der Daten aus Datei $datei.\n";
   open(DATEN, $datei) || die("Konnte Datei $datei nicht ffnen : $!\n");
   for ($a=0; $a<4; $a++) { # dier ersten 3 Zeilen enthalten Kennzahlen
      $_=<DATEN>;
      chomp($_);
      while ($_=~/ /) { $_=~s/ //;}
      ($b, $c)=split(/:/, $_);
      push(@data, $c);}
   ($arbeitssys, $lmax, $bimin)=@data;
   if ($lmax==0) { # Spter wird durch Lmax geteilt, daher Division durch Null abfangen
      $error=1;
      $lmax=1;}

   <DATEN>; # nchsten beiden Zeilen sind Leerzeile und Tabellenkopf
   <DATEN>;

   while (<DATEN>) { # Lese jetzt die Werte ein
      chomp;
      @data=split(/;/); #/
      push(@xwert, $data[1]);
      push(@ywert1, $data[2]);
      push(@ywert2, $data[3]);}
   close(DATEN);

   # Jetzt einige Koordinaten und Faktoren berechnen
   $nullx=$randl;
   $nully=$hoehe-$randu;
   $tiefe=$hoehe-$rando-$randu;
   $weite=$breite-$randl-$randr;
   $xscale=$weite/$xwert[-1]; #/
   $yscale1=$tiefe/$lmax;       #/
   $yscale2=$tiefe/$ywert2[-1]; #/

   # Jetzt das Bild vorbereiten
   print "Zeichne Produktionskennlinie fr Arbeitssystem $arbeitssys.\n";
   $bild=GD::Image->new($breite, $hoehe);
   $color{"weiss"}  = $bild->colorAllocate(255,255,255); # wei ist automatisch Hintergrundfarbe
   $color{"schwarz"}= $bild->colorAllocate(0,0,0);
   $color{"blau"}   = $bild->colorAllocate(0,0,200);
   $color{"rot"}    = $bild->colorAllocate(200,0,0);
   $color{"gruen"}  = $bild->colorAllocate(0,200,0);
   $color{"gelb"}   = $bild->colorAllocate(0,150,150);

   # Den Fall Lmax=0 durch Fehlermeldung abfangen
   if ($error) {
      $bild->string(gdLargeFont, $nullx+30, $nully-int($tiefe/2), "Fehler : Lmax=0 ! Kennlinie unbrauchbar !", $color{"rot"});} #/

   # Achsen und Skalierung zeichnen
   # Verbesserungsmglichkiet: statt einzelner Linien Rechteck zeichnen !
   for ($a=1; $a<($linie1+1); $a++) {  # Achsen zeichnen
      $bild->line($nullx, $nully+$a, $nullx+$weite, $nully+$a, $color{"schwarz"});  # x-Achse
      $bild->line($nullx-$a, $rando, $nullx-$a, $nully+$linie1, $color{"schwarz"}); # y1-Achse
      $bild->line($nullx+$weite+$a, $rando, $nullx+$weite+$a, $nully+$linie1, $color{"schwarz"});} # y2-Achse

   for ($a=0; $a<11; $a++) { # Skalen zeichnen, je 10 Teilstriche
      $b=int($tiefe*($a/10)); #/ # die Anzahl Pixel fr y-Achse
      $c=int($weite*($a/10)); #/ # die Anzahl Pixel fr x-Achse
      $bild->line($nullx+$c, $nully+1, $nullx+$c, $nully+10, $color{"schwarz"});  # x-Achse
      $bild->line($nullx-1, $nully-$b, $nullx-10, $nully-$b, $color{"schwarz"});  # y1-Achse
      $bild->line($nullx+$weite+1, $nully-$b, $nullx+$weite+10, $nully-$b, $color{"schwarz"});} # y2-Achse

   # Achsenbeschriftung
   $bild->stringUp(gdSmallFont, int($randl/2)-12, int($hoehe/2)-42 ,"Leistung [h/d]", $color{"blau"}); # y1-Achse, Leistung, links
   $bild->stringUp(gdSmallFont, $breite-int($randr/2), int($hoehe/2)-42 ,"Reichweite [d]", $color{"rot"}); # y2-Achse, Reichweite, rechts
   $bild->string(gdSmallFont, int($breite/2)-33, $hoehe-int($randu/2), "Bestand [h]", $color{"schwarz"}); # x-Achse, unten

   # Diagrammbeschriftung
   $bild->string(gdLargeFont, int($breite/4), int($rando/2)-8, "Produktionskennlinie Arbeitssystem $arbeitssys", $color{"schwarz"});

   # Skalenbeschriftung
   for ($a=0; $a<11; $a++) {
      $b=int($tiefe*($a/10)); #/ # die Anzahl Pixel fr y-Achse, durch 11 teilen, da oben yscale*1.1
      $c=int($weite*($a/10)); #/ # die Anzahl Pixel fr x-Achse
      $d=int($xwert[-1]*($a/10)); #/
      $bild->string(gdSmallFont, $randl+int($c)-6, $hoehe-$randu+15, "$d", $color{"schwarz"});
      $d=int($ywert1[-1]*($a/10)); #/
      $bild->stringUp(gdSmallFont, $randl-27, $hoehe-$randu-int($b)+6, "$d", $color{"schwarz"});
      $d=int($ywert2[-1]*($a/10)); #/
      $bild->stringUp(gdSmallFont, $breite-$randr+15, $hoehe-$randu-int($b)+6, "$d", $color{"schwarz"});}

   # Nun die Kurven zeichnen
   $altx=$nullx;   # $altx, $alty1, $alty2 werden als Anfangspunkt der Linien benutzt
   $alty1=$nully;  # Maeinheit ist Pixel !

   $alty2=$nully-int($ywert2[0]*$yscale2);

   for ($a=1; $a<@xwert; $a++) {
      $b=$nullx+int($xwert[$a]*$xscale); # Werte in Pixel umrechnen
      $c=$nully-int($ywert1[$a]*$yscale1);
      $d=$nully-int($ywert2[$a]*$yscale2);
      $bild->line($altx, $alty1, $b, $c, $color{"blau"}); # Leistungskennlinie y1
      $bild->line($altx, $alty2, $b, $d, $color{"rot"});  # Reichweite y2
      $altx=$b;
      $alty1=$c;
      $alty2=$d;}

   # Zum Schlu noch Lmax und BImin eintragen
   $a=$nully-int($lmax*$yscale1);
   $b=$nullx+int($bimin*$xscale);
   $bild->line($nullx, $a, $nullx+$weite, $a, $color{"gruen"}); # Lmax
   $bild->line($b, $rando+1, $b, $nully, $color{"gelb"}); # BImin
   $bild->string(gdSmallFont, $b+10, $nully-40, "BImin", $color{"gelb"});
   $bild->string(gdSmallFont, $nullx+10, $a-15, "Lmax", $color{"gruen"});

   # Ausgabe des Diagramms
   $a=$dir."pkl_$arbeitssys.png";
   print "Speichere Produktionskennlinie in Datei $a\n\n";
   open(OUTPUT, ">$a") || die("Konnte Datei $a nicht ffnen : $!\n");
   binmode OUTPUT;
   print OUTPUT $bild->png;
   close(OUTPUT);
   }

# ---------- Hauptprogramm ----------
print <<ANNOUNCE;
DrawPKL v1.0.2 - zeichnet Produktionskennlinien
Copyright (C) 2001, 2002 Dirk Swiniartzki pamela\@planet-dirk.de

Dieses Programm ist freie Software. Sie knnen es unter
den Bedingungen der GNU General Public License Version 2,
wie von der Free Software Foundation herausgegeben, weitergeben
und/oder modifizieren.

Die Verffentlichung dieses Programms erfolgt in der
Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE JEDE
GEWHRLEISTUNG - sogar ohne die implizite Gewhrleistung
der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
ANNOUNCE

print "\nSyntax : drawpkl.plx <Verzeichnis>\n";

@config=init(); # @config= siehe init();
if (@ARGV>0) {
   $b=$ARGV[0];}
else {
   $b="./";}
$b.="pkl_*.csv";
@files=glob($b); # Dateiliste einlesen

foreach $a (@files) {
   drawpkl(@config, $a);}

__END__


