#!/usr/bin/perl -w

use strict;

# pamconfig v1.0.2 - konfiguriert PameLa
# Copyright (C) 2001, 2002 Dirk Swiniartzki (pamela@planet-dirk.de)
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of the GNU General Public License version 2
#    as published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
#    General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#    -----------------------------------------------------------
#    Dieses Programm ist freie Software. Sie knnen es unter
#    den Bedingungen der GNU General Public License Version 2,
#    wie von der Free Software Foundation herausgegeben, weitergeben
#    und/oder modifizieren.
#
#    Die Verffentlichung dieses Programms erfolgt in der
#    Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE JEDE
#    GEWHRLEISTUNG - sogar ohne die implizite Gewhrleistung
#    der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN ZWECK.
#    Details finden Sie in der GNU General Public License.
#
#    Sie sollten eine Kopie der GNU General Public License zusammen
#    mit diesem Programm erhalten haben. Falls nicht, schreiben Sie
#    an die Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
#    MA 02139, USA.
#    ----------------------------------------------------------------

my ($a, $b, $c);     # temporre Variablen
my $file;            # Name der Konfigurationsdatei
my @config;          # Nimmt die Konfigurationsdaten auf

print <<ANNOUNCE;
pamconfig v1.0.2 - erzeugt eine Konfigurationsdatei fr PameLa
Copyright (C) 2001, 2002 Dirk Swiniartzki pamela\@planet-dirk.de

Dieses Programm ist freie Software. Sie knnen es unter
den Bedingungen der GNU General Public License Version 2,
wie von der Free Software Foundation herausgegeben, weitergeben
und/oder modifizieren.

Die Verffentlichung dieses Programms erfolgt in der
Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE JEDE
GEWHRLEISTUNG - sogar ohne die implizite Gewhrleistung
der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN ZWECK.
Details finden Sie in der GNU General Public License.
ANNOUNCE

print "\nSyntax : pamconfig.plx\n\n";

print "In das Ergebnisverzeichnis werden alle Dateien, die PameLa generiert, geschrieben.\n";
do {
   $b="n";
   print "In welchem Verzeichnis sollen die Ergebnisse geschrieben werden ? ";
   $a=<STDIN>;
   chomp($a);
   unless (-e $a) {
       print "Das Verzeichnis existiert nicht !\nEingabe korrigieren ? (j/n)";
       $b=<STDIN>;
       chomp($b);
       $b="j" if ($b=~/^[jJ]/);}}
   until ($b="n");
push(@config, "resultdirectory=$a\n");

print "\nDie Auftragsdatei enthlt alle auftragsspezifischen Daten.\n";
do {
    $b="n";
    print "\nBitte geben Sie den Namen der Auftragsdatei ein : ";
    $a=<STDIN>;
    chomp($a);
    unless (-e $a) {
        print "Die Datei $a existiert nicht !\nEingabe korrigieren (j/n) ? ";
        $b=<STDIN>;
        chomp($b);
        $b="j" if ($b=~/j/);}}
    until ($b="n");
push(@config, "orderfile=$a\n");

do {
   $b="n";
   print "\nBitte geben Sie den Namen der Arbeitsplandatei ein : ";
   $a=<STDIN>;
   chomp($a);
   unless (-e $a) {
      print "Die Datei $a existiert nicht !\nEingabe korrigieren (j/n) ? ";
      $b=<STDIN>;
      chomp($b);
      $b="j" if ($b=~/^[jJ]/);}}
   until ($b="n");
push(@config, "workplanfile=$a\n");

print "Die Arbeitszeitdatei legt die Arbeitszeiten vom Referenzdatum bis zum letzten Rckmeldedatum fest.\n";
do {
   $b="n";
   print "\nBitte geben Sie den Namen der Arbeitszeitdatei ein : ";
   $a=<STDIN>;
   chomp($a);
   unless (-e $a) {
      print "Die Datei $a existiert nicht !\nEingabe korrigieren (j/n) ? ";
      $b=<STDIN>;
      chomp($b);
      $b="j" if ($b=~/^[jJ]/);}}
   until ($b="n");
push(@config, "calendar=$a\n");

print "\nDer Beginn des Untersuchungszeitraumes legt das Datum fest, ab dem\nAuftragsdaten in den Ergebnissen bercksichtigt werden.\n";
print "Das Datum mu das Format tt.mm.jjjj haben.\n";
do {
   $b="n";
   print "Bitte geben Sie den Beginn des Untersuchungszeitraumes ein : ";
   $a=<STDIN>;
   chomp($a);
   unless ($a=~/\d{1,2}\.\d{1,2}\.\d{4}/) {
      print "$a ist kein gltiges Datum !\n";
      $b="j";}}
   until ($b="n");
push(@config, "startdate=$a\n");

print "\nDas Ende des Untersuchungszeitraumes legt das Datum fest, nach dem Auftragsdaten nicht mehr in die Ergebnisse einflieen.\n";
print "Das Datum mu das Format tt.mm.jjjj haben.\n";
do {
   $b="n";
   print "Bitte geben Sie das Ende des Untersuchungszeitraumes ein : ";
   $a=<STDIN>;
   chomp($a);
   unless ($a=~/\d{1,2}\.\d{1,2}\.\d{4}/) {
      print "$a ist kein gltiges Datum !\n";
      $b="j";}}
   until ($b="n");
push(@config, "enddate=$a\n");

print "Das Referenzdatum gilt als Nullwert bei der Umrechnung der Datumsangaben in dezimale Kalendertage.\n";
print "Das Referenzdatum ist der erste Tag, fr den Arbeitszeiten definiert sein mssen.\n";
print "Sie sollten es daher mglichst nahe an das erste vorkommende Freigabedatum legen.\n";
do {
   $b="n";
   print "Bitte geben Sie das Referenzdatum ein : ";
   $a=<STDIN>;
   chomp($a);
   unless ($a=~/\d{1,2}\.\d{1,2}\.\d{4}/) {
      print "$a ist kein gltiges Datum !\n";
      $b="j";}}
   until ($b="n");
push(@config, "referencedate=$a\n");

print "Das Zeitfenster fr pnktliche Auftrge legt fest, in welchem Bereich um seinen Soll-Endtermin ein Auftrag als pnktlich gelten soll.\n";
print "Die Angabe erfolgt in Tagen in der Form \"<linke Grenze>;<rechte Grenze>\".\n";
print "Beispiel :\nDie Angabe \"-3;0\" definiert alle Auftrge als pnktlich, die hchstens 3 Tage zu frh fertig werden.\n";
print "Alle Auftrge, die nach dem Soll-Endtermin oder frher als drei Tage vorher fertig werden, gelten als nicht pnktlich.\n";
print "Das Zeitfenster gilt einschlielich der angegebenen Grenzen.\n\n";
do {
   $b="n";
   print "Bitte geben Sie das Zeitfenster fr pnkliche Auftrge ein : ";
   $a=<STDIN>;
   chomp($a);
   unless ($a=~/;/) {
      print "$a hat kein gltiges Format !\n";
      $b="j";}}
   until ($b="n");
push(@config, "intime=$a\n");

print "Die Klasseneinteilung wird zur Berechnung der Verteilungen der Auftrags- und der Durchlaufzeit verwendet.\n";
print "Die Angabe erfolgt in der Form \"<bis exklusive ...>;<bis exklusive ...>;...\".\n";
print "Beispiel :\nDie Angabe \"10;20;30;40;50\" definiert die Klassen \"bis 10\", \"bis 20\", \"bis 30\", \"bis 40\", \"bis 50\", \"50 und hher\".\n";
do {
   $b="n";
   print "Bitte geben Sie die Klasseneinteilung ein : ";
   $a=<STDIN>;
   chomp($a);
   unless ($a=~/;/) {
      print "$a hat kein gltiges Format !\n";
      $b="j";}}
   until ($b="n");
push(@config, "classes=$a\n");

print "----------------------------------------------------------------------\n";
print "Die Konfiguration ist jetzt abgeschlossen.\n";
print "Bitte geben Sie einen Namen fr die Konfigurationsdatei ein : ";
$a=<STDIN>;
chomp($a);
open(DATEI, ">$a") || die("Konnte Datei $a nicht anlegen : $!\n");
print "# Konfigurationsdatei erstellt mit latconfig\n";
foreach $b (@config) {
   print DATEI $b;}
close(DATEI);
print "\nDie Konfigurationsdatei $a wurde erstellt.\n";


